/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is DogStar SOFTWARE PiXML Public Module.
 *
 * The Initial Developer of the Original Code is
 * James Tyson, DogStar SOFTWARE <james@thedogstar.org>.
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   None.
 *
 * ***** END LICENSE BLOCK ***** */

int integer = 1;
float floater = 2.0;
string wassat = "hello world\n";
array testarray = ({ integer, floater, wassat });
multiset testmultiset = (< integer, floater, wassat, testarray >);
mapping testmapping = ([ "a" : integer, "b" : floater, "c" : wassat, "d" : testarray, "e" : testmultiset, testarray : testmultiset ]);
constant testconstant = "I'm constantly here";
#if constant(Image.PNG.decode)
object testimage = Image.PNG.decode(#string"test.png");
#endif

void create() {
  write("PiJAX %s test suite.\n", PiJAX.__version);
  mapping test = mkmapping(indices(this_object()), values(this_object()));
  string xml = PiJAX.serialise(test, PiJAX.XML);
  object node = PiJAX.serialise(test, PiJAX.NODE);
  if (stringp(xml) && sizeof(xml)) {
    write("Serialisation works fine, XML output %d bytes\n", sizeof(xml));
    write("Dumping serialised XML to test.xml\n");
    Stdio.write_file("test.xml", xml);
  }
  mapping test2 = PiJAX.parse(xml);
  mapping test3 = PiJAX.parse(node);
  if (test2 && test3 && mappingp(test2) && mappingp(test3))
    write("Parsing works fine.\n");
}
